【leetcode】377. Combination Sum IV【M】

175 篇文章 0 订阅
157 篇文章 0 订阅

Given an integer array with all positive numbers and no duplicates, find the number of possible combinations that add up to a positive integer target.

Example:

nums = [1, 2, 3]
target = 4

The possible combination ways are:
(1, 1, 1, 1)
(1, 1, 2)
(1, 2, 1)
(1, 3)
(2, 1, 1)
(2, 2)
(3, 1)

Note that different sequences are counted as different combinations.

Therefore the output is 7.

Follow up:
What if negative numbers are allowed in the given array?
How does it change the problem?
What limitation we need to add to the question to allow negative numbers?

Credits:
Special thanks to @pbrother for adding this problem and creating all test cases.

Subscribe to see which companies asked this question

动态规划,应该算是比较经典的无限背包问题

从1到target,

dp[i] = ∑ dp[i-j] (j<=0 and j < i) 求和

最后dp[target] 就是结果





class Solution(object):
    def combinationSum4(self, nums, target):

        nums.sort()
        #print nums

        res = [0] * (target+1)
        res[0] = 1


        for i in xrange(1,target+1):
            t = 0
            #print res
            for j in nums:
                #print i,j
                if j > i:
                    break
                t += res[i-j]
            res[i] = t
        return res[-1]

        """
        :type nums: List[int]
        :type target: int
        :rtype: int
        """


评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值